/**
 \file image_effects.h
 \brief Fonctions d'effets et transformations sur des images.
 
 Created by Valentin Emiya on 09/03/12.\n
 Copyright (c) 2012 LIF. All rights reserved.
*/

#ifndef _image_effects_h
#define _image_effects_h

#include "image_types.h"
#include "image_utils.h"

/**
 \brief Négatif d'une image
 
 Transforme une image en son négatif. L'image fournie est modifiée.
 \param p_image pointeur vers l'image à transformer
*/
void negative_effect(Image *p_image);

/**
 \brief Binarisation d'une image.
 
 Transforme une image en sa version binaire. L'image fournie est modifiée.
 \param p_image pointeur vers l'image à transformer
 */
void binarization_effect(Image *p_image);

/**
 A documenter
*/
Image *miroir_horizontal(Image *p_image);

/**
 A documenter
 */
Image *miroir_vertical(Image *p_image);

/**
 A documenter
 */
Image *rotation90_droite(Image *p_image);

/**
 A documenter
 */
Image *rotation180(Image *p_image);

/**
 A documenter
 */
Image *rotation90_gauche(Image *p_image);

/**
 A documenter
 */
Image *mean_filter(Image *p_image);

/**
 A documenter
 */
Image *median_filter(Image *p_image);

#endif
