/**
 \file test_image_processing_TP7.c
 \brief Fichier test pour les fonctions développées dans le TP8.
 
 Created by Valentin Emiya on 06/03/12.\n
 Copyright (c) 2012 LIF. All rights reserved.
 */

#include <stdio.h>
#include "imageio.h"
#include "image_utils.h"
#include "image_effects.h"

/** Programme principal */
int main(void){
    int max = 255;
    char * filename;
    Image *p_image, *p_image2;
    
    /* filename = "../data/feep.pgm"; */
    filename = "../data/homer_ascii.pgm";
    
    p_image = pgm_read(filename); /* lecture image */
    
    /* test de l' affichage */
    affiche_image(p_image);
    
    /* test de l'écriture */
    pgm_write("../data/out/test_write.pgm", p_image, max);
    
    /* test de la copie */
    p_image2 = copy_image(p_image);
    pgm_write("../data/out/test_copy.pgm", p_image, max);
    
    /* test effet binarisation */
    binarization_effect(p_image2);
    affiche_image(p_image2);
    pgm_write("../data/out/test_binarized.pgm", p_image2, max);  
    
    /* test effet négatif */
    negative_effect(p_image);
    affiche_image(p_image);
    pgm_write("../data/out/test_negative.pgm", p_image, max);
    
    free_image(p_image);
    free_image(p_image2);
    return 0;
}