/**
 \file test_image_processing_TP8.c
 \brief Fichier test pour les fonctions développées dans le TP8.
 
 Created by Valentin Emiya on 06/03/12.\n
 Copyright (c) 2012 LIF. All rights reserved.
*/

#include <stdio.h>
#include "imageio.h"
#include "image_utils.h"
#include "image_effects.h"

/** Programme principal */
int main(void){
    int max = 255;
    char * filename;
    Image *p_image, *p_image2;
    
    /* Débruitage d'une image avec bruit impulsionnel */
    filename = "../data/number72_impulsive_noise.pgm";
    /*filename = "../data/feep.pgm";*/
    /*filename = "../data/homer_ascii.pgm";*/
    
    p_image = pgm_read(filename); /* lecture image */
    
    /* test des miroirs et rotations */
    p_image2 = miroir_horizontal(p_image);
    pgm_write("../data/out/test_miroirH.pgm", p_image2, max);
    free_image(p_image2);
    p_image2 = miroir_vertical(p_image);
    pgm_write("../data/out/test_miroirV.pgm", p_image2, max);
    free_image(p_image2);
    p_image2 = rotation90_droite(p_image);
    pgm_write("../data/out/test_rotation90d.pgm", p_image2, max);
    free_image(p_image2);
    p_image2 = rotation180(p_image);
    pgm_write("../data/out/test_rotation180.pgm", p_image2, max);
    free_image(p_image2);
    p_image2 = rotation90_gauche(p_image);
    pgm_write("../data/out/test_rotation90g.pgm", p_image2, max);
    free_image(p_image2);

    /* test du filtrage moyen */
    p_image2 = mean_filter(p_image);
    pgm_write("../data/out/test_impulsive_noise_mean_filter.pgm", p_image2, max);
    free_image(p_image2);

    
    /* test du filtrage médian */
    p_image2 = median_filter(p_image);
    pgm_write("../data/out/test_impulsive_noise_median_filter.pgm", p_image2, max);
    free_image(p_image2);
    free_image(p_image);
    
    /* Débruitage d'une image avec bruit blanc */
    filename = "../data/lacornouaille_white_noise.pgm";
    p_image = pgm_read(filename); /* lecture image */

    /* test du filtrage moyen */
    p_image2 = mean_filter(p_image);
    pgm_write("../data/out/test_white_noise_mean_filter.pgm", p_image2, max);
    free_image(p_image2);
    
    
    /* test du filtrage médian */
    p_image2 = median_filter(p_image);
    pgm_write("../data/out/test_white_noise_median_filter.pgm", p_image2, max);
    free_image(p_image2);
    free_image(p_image);

    /* A compléter */
    
    return 0;
}